// ScrutePDFsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ScrutePDFs.h"
#include "ScrutePDFsDlg.h"

#include <shlwapi.h>
#include <map>
#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define LIST_COL_PRODUIT        0  
#define LIST_COL_NOMBRE         1  
#define LIST_COL_DATE_HEURE     2  

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CScrutePDFsDlg dialog




CScrutePDFsDlg::CScrutePDFsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScrutePDFsDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScrutePDFsDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_LIST, m_ctlList);
  DDX_Control(pDX, IDC_LIST2, m_ctlListPDFs);
  DDX_Control(pDX, IDC_SEQUENCEUR, m_ctlSeq);
}

BEGIN_MESSAGE_MAP(CScrutePDFsDlg, CDialog)
  ON_WM_TIMER()
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDC_BUTTON1, &CScrutePDFsDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CScrutePDFsDlg message handlers

BOOL CScrutePDFsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
  std::vector<std::string> tabEntrees;
  tabEntrees.push_back(std::string(_T("Y:\\")));
  tabEntrees.push_back(std::string(_T("S:\\")));

  std::vector<std::string>::const_iterator itEntrees;
  for ( itEntrees = tabEntrees.begin() ; itEntrees != tabEntrees.end() ; ++itEntrees )
  {
	  std::string strRecherche = *itEntrees + "*.*";
    HANDLE hFindRepertoires;
    WIN32_FIND_DATA fileFindData;

    hFindRepertoires = FindFirstFile(strRecherche.c_str(), &fileFindData);
	  if ( hFindRepertoires != INVALID_HANDLE_VALUE )
	  {
	    do
	    {
	      // On recherche tous les rpertoires uniquement
	      if ( (fileFindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY )
	      {
	        std::string strRepertoireProduit(fileFindData.cFileName);

	        // Un rpertoire qui convient a notre affaire contient un sous-rpertoire "out"
	        // On vrifie qu'un que le chemin avec le rpertoire courant ainsi que "out" existe bien
          std::string strNouveauRepertoire = *itEntrees + strRepertoireProduit + "\\out";
          if ( PathFileExists(strNouveauRepertoire.c_str()) )
          {
            // Le chemin existe, on l'ajoute a la liste des rpertoires a surveiller.
            listRepertoires.push_back(strNouveauRepertoire);
          }
	      }
	    }
	    while(FindNextFile(hFindRepertoires, &fileFindData));
	    FindClose(hFindRepertoires);
	  }

  }

	listRepertoires.sort();
	std::list < std::string > :: const_iterator itRepertoires;
	for ( itRepertoires = listRepertoires.begin() ; itRepertoires != listRepertoires.end() ; ++itRepertoires )
	{
    m_ctlList.AddString((*itRepertoires).c_str());
	}

  m_ctlSeq.InsertColumn (LIST_COL_PRODUIT,    _T("Produit"),                LVCFMT_LEFT,    50);
  m_ctlSeq.InsertColumn (LIST_COL_NOMBRE,     _T("Nombre"),                 LVCFMT_CENTER,  100);
  m_ctlSeq.InsertColumn (LIST_COL_DATE_HEURE, _T("Date Heure plus ancien"), LVCFMT_CENTER,  100);
  m_ctlSeq.SetExtendedStyle(m_ctlSeq.GetExtendedStyle() | LVS_EX_FULLROWSELECT);

  m_timerId = SetTimer(1, 2000, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CScrutePDFsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CScrutePDFsDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CScrutePDFsDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void GetLocalFileTime(SYSTEMTIME * pLocalTime, const FILETIME * const pFileTime)
{
  SYSTEMTIME fileTime, localTime;
 
  FileTimeToSystemTime(pFileTime, &fileTime);
  SystemTimeToTzSpecificLocalTime(NULL, &fileTime, &localTime);

  memcpy(pLocalTime, &localTime, sizeof(SYSTEMTIME));
}


// Sort items by associated lParam
static int CALLBACK  MyCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{

  CTime t1 (* reinterpret_cast<const FILETIME*> (lParam1));
  CTime t2 (* reinterpret_cast<const FILETIME*> (lParam2));

  TRACE(t1.Format(_T("Time 1 : %d/%m/%Y - %H:%M:%S\n")));
  TRACE(t2.Format(_T("Time 2 : %d/%m/%Y - %H:%M:%S\n")));

  if (t1 == t2)
    return 0;
  else
    return (t1 < t2 ? 1 : -1);

/*
  FILETIME * time1 = (FILETIME *) lParam1;
  FILETIME * time2 = (FILETIME *) lParam2;

  long result = CompareFileTime(time1, time2);

  if ( lParamSort == 0 )
    return -result;
  return result;
*/
/*
  SYSTEMTIME  * time1 = (SYSTEMTIME*) lParam1;
  SYSTEMTIME  * time2 = (SYSTEMTIME*) lParam2;


  CString strFormatHeure;
  TRACE(_T("Comparaison de :\n"));
  strFormatHeure.Format(_T("%02d-%02d-%04d  %02d:%02d:%02d\n"), 
                  time1->wDay, time1->wMonth, time1->wYear, time1->wHour, time1->wMinute, time1->wSecond);
  TRACE(strFormatHeure);
  strFormatHeure.Format(_T("%02d-%02d-%04d  %02d:%02d:%02d\n"), 
                  time1->wDay, time1->wMonth, time1->wYear, time1->wHour, time1->wMinute, time1->wSecond);
  TRACE(strFormatHeure);

  if ( memcmp(time1, time2, sizeof(SYSTEMTIME)) == 0 ) return 0;

  if ( (time1->wYear < time2->wYear) || (time1->wMonth < time2->wMonth) || (time1->wDay < time2->wDay) ||
       (time1->wHour < time2->wHour) || (time1->wMinute < time2->wMinute) || (time1->wSecond < time2->wSecond) )
  {
    if ( lParamSort == 0 ) { TRACE(_T("Resultat : -1\n")); return -1; }
    else  { TRACE(_T("Resultat : 1\n")); return 1; }
  }
  else if ( lParamSort == 0 )  { TRACE(_T("Resultat : 1\n")); return 1; }
  else { TRACE(_T("Resultat : -1\n")); return -1; }
*/
/*
  CFileStatus statusFile1, statusFile2;
  CFile::GetStatus((LPCTSTR)lParam1, statusFile1);
  CFile::GetStatus((LPCTSTR)lParam2, statusFile2);

  if ( statusFile1.m_ctime > statusFile2.m_ctime )
  {
    if ( lParamSort == 0 ) return 1; 
    else return -1;
  }
  if ( statusFile1.m_ctime < statusFile2.m_ctime ) 
  {
    if ( lParamSort == 0 ) return -1; 
    else return 1;
  }
*/
/*
  int n1 = (int) lParam1;
  int n2 = (int) lParam2;

  TRACE2(_T("Nombre 1 : %d -- Nombre 2 : %d \n"), n1, n2);

  if ( n1 > n2 )
  {
    if ( lParamSort == 0 ) return 1; 
    else return -1;
  }
  if ( n1 < n2 )
  {
    if ( lParamSort == 0 ) return -1; 
    else return 1;
  }
*/
  return 0;
}
void CScrutePDFsDlg::OnTimer(UINT_PTR nIDEvent)
{

  CDialog::OnTimer(nIDEvent);
}

void CScrutePDFsDlg::OnBnClickedButton1()
{
  std::list < std::string > :: const_iterator itRepertoires;

  std::multimap < std::string , _SProduitFile > mapFiles;

  m_ctlListPDFs.ResetContent();
  m_ctlSeq.DeleteAllItems();
  for ( itRepertoires = listRepertoires.begin() ; itRepertoires != listRepertoires.end() ; ++itRepertoires )
  {
    std::string strPointEntree = *itRepertoires;
    std::string strRecherche = strPointEntree + _T("\\*.PDF");
    HANDLE hFindPDFs;
    WIN32_FIND_DATA fileFindData;

    hFindPDFs = FindFirstFile(strRecherche.c_str(), &fileFindData);
    if ( hFindPDFs != INVALID_HANDLE_VALUE )
    {
      do
      {
        // On recherche les fichiers uniquement
        if ( (fileFindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0 )
        {
          std::string strPathComplet = strPointEntree + _T("\\") + fileFindData.cFileName;

          std::string strProduit = std::string(fileFindData.cFileName);
          strProduit.erase(strProduit.begin() + 2, strProduit.end());
          _SProduitFile fichier;
          fichier.m_strFileName = strPathComplet.c_str();
          fichier.m_fileTime = fileFindData.ftLastWriteTime;

          mapFiles.insert(std::multimap<std::string, _SProduitFile>::value_type(strProduit, fichier));

        }
      }
      while(FindNextFile(hFindPDFs, &fileFindData));
      FindClose(hFindPDFs);
    }
  }

  _SProduitFile plusVieux;
  std::string strProduitCourant = _T("");
  int nCountPrd;

  std::multimap<std::string, _SProduitFile>::const_iterator itFiles;
  for ( itFiles = mapFiles.begin() ; itFiles != mapFiles.end() ; ++itFiles )
  {
    std::string strProduit = itFiles->first;
    _SProduitFile fileData = itFiles->second;

    if ( strProduitCourant != _T("") )
    {
      if ( strProduitCourant != strProduit )
      {
        m_ctlListPDFs.AddString(_T("---------------------------------------------------------------------------------------"));
        SYSTEMTIME localTime;
        GetLocalFileTime(&localTime, &plusVieux.m_fileTime);
        CString strFormatHeure;
        strFormatHeure.Format(_T("Fichier le plus vieux pour les %s, date du %02d-%02d-%04d  %02d:%02d:%02d et s'appelle %s"), 
                              strProduitCourant.c_str(),
                              localTime.wDay, localTime.wMonth, localTime.wYear, localTime.wHour, localTime.wMinute, localTime.wSecond,
                              plusVieux.m_strFileName.c_str());
        m_ctlListPDFs.AddString(strFormatHeure);

        int nItem = m_ctlSeq.GetItemCount();
        m_ctlSeq.InsertItem (nItem, strProduitCourant.c_str());
        strFormatHeure.Format(_T("%d"), nCountPrd);
        m_ctlSeq.SetItem (nItem, LIST_COL_NOMBRE,     LVIF_TEXT, strFormatHeure, 0, 0, 0, 0);
        strFormatHeure.Format(_T("%02d-%02d-%04d  %02d:%02d:%02d"), 
                        localTime.wDay, localTime.wMonth, localTime.wYear, localTime.wHour, localTime.wMinute, localTime.wSecond);
        m_ctlSeq.SetItem (nItem, LIST_COL_DATE_HEURE, LVIF_TEXT, strFormatHeure, 0, 0, 0, 0);

        m_ctlSeq.SetItemData(nItem, (DWORD_PTR)&plusVieux.m_fileTime);
        strProduitCourant = strProduit;
        plusVieux.m_strFileName = _T("");
        nCountPrd = 0;
      }
    }
    else
    {
      nCountPrd = 0;
      strProduitCourant = strProduit;
      plusVieux.m_strFileName = _T("");
    }

    if ( plusVieux.m_strFileName == _T("") )
    {
      if ( CompareFileTime(&fileData.m_fileTime, &plusVieux.m_fileTime) == -1 )
      {
        plusVieux.m_strFileName = fileData.m_strFileName;
        memcpy(&plusVieux.m_fileTime, &fileData.m_fileTime, sizeof(FILETIME));
      }
    }
    else
    {
      plusVieux.m_strFileName = fileData.m_strFileName;
      memcpy(&plusVieux.m_fileTime, &fileData.m_fileTime, sizeof(FILETIME));
    }

    SYSTEMTIME fichierLocalTime;
    GetLocalFileTime(&fichierLocalTime, &fileData.m_fileTime);
    CString strFormat;
    strFormat.Format(_T("Produit %s, fichier %s, date %02d-%02d-%04d  %02d:%02d:%02d"), 
                    strProduit.c_str(), 
                    fileData.m_strFileName.c_str(), 
                    fichierLocalTime.wDay, fichierLocalTime.wMonth, fichierLocalTime.wYear, fichierLocalTime.wHour, fichierLocalTime.wMinute, fichierLocalTime.wSecond);
    m_ctlListPDFs.AddString(strFormat);

    nCountPrd++;
  }

  m_ctlListPDFs.AddString(_T("---------------------------------------------------------------------------------------"));
  CString strFormat;
  SYSTEMTIME localTime;
  GetLocalFileTime(&localTime, &plusVieux.m_fileTime);
  strFormat.Format(_T("Fichier le plus vieux pour les %s, date du %02d-%02d-%04d  %02d:%02d:%02d et s'appelle %s"), 
                  strProduitCourant.c_str(),
                  localTime.wDay, localTime.wMonth, localTime.wYear, localTime.wHour, localTime.wMinute, localTime.wSecond,
                  plusVieux.m_strFileName.c_str());
  m_ctlListPDFs.AddString(strFormat);

  int nItem = m_ctlSeq.GetItemCount();
  m_ctlSeq.InsertItem (nItem, strProduitCourant.c_str());
  strFormat.Format(_T("%d"), nCountPrd);
  m_ctlSeq.SetItem (nItem, LIST_COL_NOMBRE,     LVIF_TEXT, strFormat, 0, 0, 0, 0);
  strFormat.Format(_T("%02d-%02d-%04d  %02d:%02d:%02d"), 
                  localTime.wDay, localTime.wMonth, localTime.wYear, localTime.wHour, localTime.wMinute, localTime.wSecond);
  m_ctlSeq.SetItem (nItem, LIST_COL_DATE_HEURE, LVIF_TEXT, strFormat, 0, 0, 0, 0);
  m_ctlSeq.SetItemData(nItem, (DWORD_PTR)&plusVieux.m_fileTime);
  m_ctlSeq.SortItems(MyCompareProc, (LPARAM) 0);
}
